#ifndef EXTRACTOMFWALKER_H
#define EXTRACTOMFWALKER_H

#include"DefaultTranslatingWalker.h"
#include<OMF/OMF.hpp>
#include<OMF/Model.hpp>
#include<UML/Model.hpp>
#include<Model/ModelLibrary.hpp>
#include<UML/Namespace.hpp>
#include<UML/Stereotype.hpp>

/**
 * Caution: the Walker has to iterate thougth the Ptree itself
 */
class ExtractOMFWalker : public Opencxx::DefaultTranslatingWalker
{
public:
    ExtractOMFWalker();
    virtual ~ExtractOMFWalker();
    OMF::Model *getModel() { return model_; }
    UML::Stereotype *getTypedefStereotype();
    virtual Opencxx::Ptree* TranslateNamespaceSpec(Opencxx::Ptree *);
    virtual Opencxx::Ptree* TranslateClassSpec(Opencxx::Ptree*);
    virtual Opencxx::Ptree* TranslateTypedef(Opencxx::Ptree*);
private:
    
    OMF::Model *model_;
    UML::Namespace *current_scope_;

    class Scope
    {
    public:
	Scope(ExtractOMFWalker *walker,UML::Namespace *newscope)
	{
	    walker_=walker;
	    oldscope_=walker_->current_scope_;
	    walker_->current_scope_=current_=newscope;
	    old_=walker_->currentScope_;
	    walker_->currentScope_=this;
	}
        void addOwnedElement(UML::ModelElement *element);
	~Scope()
	{
	    walker_->current_scope_=oldscope_; 
	    walker_->currentScope_=old_;
	}
    private:
	ExtractOMFWalker *walker_;
	UML::Namespace *oldscope_;
	UML::Namespace *current_;
	Scope *old_;
    };
    Scope *getScope();
    Scope *currentScope_;
    Scope *defaultScope_;
    UML::Stereotype *TypedefStereotype_;
};


#endif
