#include<iostream>
#include<occ-core/parser/Ptree.h>
#include<occ-core/parser/PtreeUtil.h>
#include<occ-core/parser/token-names.h>
#include<occ-core/parser/PtreeDeclarator.h>
#include"PtreeAnalysen.h"

void SearchDeclarator(Opencxx::Ptree *t,int stufe)
{
    if(!t) return;
    if(t->IsLeaf()) return;
    else
    {
	if(t->IsA(Opencxx::ntDeclarator))
	{
	    Opencxx::PtreeDeclarator *decl = (Opencxx::PtreeDeclarator *)t;		      
	    std::cerr << t->DumpName() << " Stufe " << stufe << " " 
		      << decl->Name()->ToString()
		      << std::endl;
	}
	int i=0;
	Opencxx::Ptree *rest=t;
	while(rest!=0)
	{
	    Opencxx::Ptree *p = rest->Car();
	    SearchDeclarator(p,stufe+1);
	    rest=rest->Cdr();
	    i++;
	}
    }
}

void DumpPtree(Opencxx::Ptree *t)
{
    if(!t) { std::cout << "empty" << std::endl; return; }
    if(t->IsLeaf()) 
    {
	std::cout << "Leaf" << t->ToString() << std::endl;
    }
    else
    {
	int i=0;
	Opencxx::Ptree *rest=t;
	while(rest!=0)
	{
	    Opencxx::Ptree *p = rest->Car();
	    if(p)
	    {
		if(p->IsLeaf())
		{
		    std::cout << "\t\t\t" << i << " Leaf \"" << p->ToString()
			      << '\"' << std::endl;
		}
		else
		{
		    std::cout << "\t\t\t" << i << " " << p->DumpName()
			      << " L=" << Opencxx::PtreeUtil::Length(p)
			      << std::endl;
		}
	    }
	    else
	    {
		std::cout << "\t\t\t" << i << " null" << std::endl;
	    }
	    rest=rest->Cdr();
	    i++;
	}
    }
}
